unit KaartHouer_U;

interface
  uses SysUtils,Math;
type
  TKaartHouer = class(TObject)
  private
    fKaartNommer: string;
    fSelNommer: string;
    fAantBesoeke: integer;
    fLojaliteitsPunte: integer;
    fGesondVlak: char;
  public
  constructor create(sKaartNommer,sSelNommer: string; iLojaliteitsPunte: integer);
  procedure setAantbesoeke(iAantBesoeke: integer);
  Procedure vermeerderLojaliteitsPunte(rTotaal: real);
  procedure opdateerGesondVlak(rGesond, rTotaal: real);
  function isReg(sToegangsKode:string): boolean;
  function identifiseerSterKoper: string;
  function toString: string;
  end;

implementation

{ TKaartHouer }
  // Vraag 2.1.1
constructor TKaartHouer.create(sKaartNommer, sSelNommer: string; iLojaliteitsPunte: integer);
begin
    fKaartNommer := sKaartNommer;
    fSelNommer := sSelNommer;
    fLojaliteitsPunte := iLojaliteitsPunte;
    fAantBesoeke := 0;
    fGesondVlak := 'S';
end;
// Vraag 2.1.2
procedure TKaartHouer.setAantbesoeke(iAantBesoeke: integer);
begin
  fAantBesoeke := iAantBesoeke;
end;
// Vraag 2.1.3
procedure TKaartHouer.vermeerderLojaliteitsPunte(rTotaal: real);
var
  iLojaliteitsPunte: integer;
begin
  fLojaliteitsPunte := fLojaliteitsPunte + trunc(rTotaal) div 4;
end;
// Vraag 2.1.4
procedure TKaartHouer.opdateerGesondVlak(rGesond, rTotaal: real);
var
  rPersent: real;
begin
  rPersent := rGesond/rTotaal * 100;
  if rPersent < 10  then
    fGesondVlak:='S'
  else
    if rPersent >= 40 then
       fGesondVlak := 'P'
    else
       fGesondVlak := 'G'
end;
// Vraag 2.1.5
function TKaartHouer.isReg(sToegangsKode: string): boolean;
var
  a: integer;
  b,iSom: integer;
  sSelNommer : string;
begin
  iSom := 0;
  sSelNommer := fSelNommer;
  for a := length(sSelNommer) downto 1 do
    if sSelNommer[a] = '0' then
      delete(sSelNommer,a,1);
  if length(sSelNommer) mod 2 = 0  then
    for b := 1 to (length(sSelNommer) div 2) do
      iSom := iSom + StrToInt(copy(sSelNommer,2*b-1,2));
  if length(sSelNommer) mod 2 <> 0  then
   begin
     iSom := StrToInt(sSelNommer[1]);
     for b := 1 to (length(sSelNommer) div 2) do
      iSom := iSom + StrToInt(copy(sSelNommer,2*b,2));
   end;
  if StrToInt(sToegangsKode) = iSom then
    result := true
  else
    result := false;
end;
// Vraag 2.1.6
function TKaartHouer.identifiseerSterKoper: string;
begin
  result := '';
  if ((fLojaliteitsPunte > 2000) AND ( fAantBesoeke > 10)) OR ( fGesondVlak = 'P') then
     result := 'STER-koper'
end;

// Kode wat voorsien is
function TKaartHouer.toString: string;
begin
  result:= fKaartNommer + #13 + 'Kontaknommer: '+ fSelNommer + #13 + #13 + 'Opgedateerde getal lojaliteitspunte: ' + IntToStr(fLojaliteitsPunte)+#13+'Getal besoeke: '+IntToStr(fAantBesoeke)+#13+'Gesondheidsevalueringstatus: ' + fGesondVlak;
end;

end.
